import * as interfaces from '../interfaces/index.js';
import * as plugins from '../plugins.js';
import { WorkerEvent } from '../classes.workerevent.js';

export const timeoutResponder: interfaces.TRequestResponser = async (cWorkerEvent: WorkerEvent) => {
  await plugins.smartdelay.delayFor(10000);
  if (cWorkerEvent.routedThroughRendertron) {
    await plugins.smartdelay.delayFor(10000);
  }
  if (!cWorkerEvent.hasResponse) {
    const errorResponse = await fetch(
      `https://nullresolve.lossless.one/custom?title=${encodeURI(
        `Lossless Network: Request Cancellation!`
      )}&heading=${encodeURI(`Error: Request Cancellation`)}&text=${encodeURI(
        `Lossless Network could not decide how to respond to this request within 5 seconds. Therefore it timed out and has been canceled.
        <p>requestUrl: ${cWorkerEvent.request.url}<br>
        requestTime: ${Date.now()}<br>
        referenceNumber: xxxxxx</p>`
      )}`
    );
    cWorkerEvent.setResponse(errorResponse);
  }
};
